%% Assemble the amazon results from all the intermediate files

%% Get the largest set
K1 = load('results-k1.mat');
K2 = load('amazon-results-all.mat');
%K3 = load('amazon-results-test.mat');
K3 = load('amazon-results-all-2.mat');
nlabels = K2.nlabels;
nerrs = K2.nerrs;
nlabels1 = K3.nlabels;
nerrs1 = K3.nerrs;

%%
ki = 1;
fprintf('\n');
fprintf('k=1\n');
fprintf('\n');
    prec_results = K1.prec_results;
    recall_results = K1.recall_results;
    reg_prec_results = K1.reg_prec_results;
    reg_recall_results = K1.reg_recall_results;
    f1 = 2*prec_results.*recall_results./(prec_results + recall_results);
    reg_f1 = 2*reg_prec_results.*reg_recall_results./(reg_prec_results + reg_recall_results);
    f1(~isfinite(f1)) = 0;
    reg_f1(~isfinite(reg_f1)) = 0;

    fprintf('%10s  %15s  %15s\n', 'num labels', 'no reg', 'reg');
    fprintf('%10s  %15s  %15s\n', '----------', '----------------','----------------');
    for li=1:numel(nlabels)
        scorevec = f1(ki,:,li,:);
        [score1,score2] = studentci(scorevec(:));
        reg_scorevec = reg_f1(ki,:,li,:);
        [reg_score1,reg_score2] = studentci(reg_scorevec(:));
        
        fprintf('%10i  [%6.4f,%6.4f]  [%6.4f,%6.4f]\n', ...
            nlabels(li), score1,score2, reg_score1, reg_score2);
        K1res(li,:) = [mean(scorevec(:)) mean(reg_scorevec(:)) score1 score2 reg_score1 reg_score2];
    end
fprintf('\n');

%%
ki = 2;
fprintf('\n');
fprintf('k=2\n');
fprintf('\n');
    prec_results = K2.prec_results;
    recall_results = K2.recall_results;
    reg_prec_results = K2.reg_prec_results;
    reg_recall_results = K2.reg_recall_results;
    f1 = 2*prec_results.*recall_results./(prec_results + recall_results);
    reg_f1 = 2*reg_prec_results.*reg_recall_results./(reg_prec_results + reg_recall_results);
    f1(~isfinite(f1)) = 0;
    reg_f1(~isfinite(reg_f1)) = 0;

    fprintf('%10s  %15s  %15s\n', 'num labels', 'no reg', 'reg');
    fprintf('%10s  %15s  %15s\n', '----------', '----------------','----------------');
    for li=1:numel(nlabels)
        scorevec = f1(ki,:,li,:);
        [score1,score2] = studentci(scorevec(:));
        reg_scorevec = reg_f1(ki,:,li,:);
        [reg_score1,reg_score2] = studentci(reg_scorevec(:));
        
        fprintf('%10i  [%6.4f,%6.4f]  [%6.4f,%6.4f]\n', ...
            nlabels(li), score1,score2, reg_score1, reg_score2);
        K2res(li,:) = [mean(scorevec(:)) mean(reg_scorevec(:)) score1 score2 reg_score1 reg_score2];
    end
fprintf('\n');

%%
ki = 3;
fprintf('\n');
fprintf('k=3\n');
fprintf('\n');
    prec_results = K3.prec_results;
    recall_results = K3.recall_results;
    reg_prec_results = K3.reg_prec_results;
    reg_recall_results = K3.reg_recall_results;
    f1 = 2*prec_results.*recall_results./(prec_results + recall_results);
    reg_f1 = 2*reg_prec_results.*reg_recall_results./(reg_prec_results + reg_recall_results);
    f1(~isfinite(f1)) = 0;
    reg_f1(~isfinite(reg_f1)) = 0;

    fprintf('%10s  %15s  %15s\n', 'num labels', 'no reg', 'reg');
    fprintf('%10s  %15s  %15s\n', '----------', '----------------','----------------');
    for li=1:numel(nlabels1)
        scorevec = f1(ki,:,li,:);
        [score1,score2] = studentci(scorevec(:));
        reg_scorevec = reg_f1(ki,:,li,:);
        [reg_score1,reg_score2] = studentci(reg_scorevec(:));
        
        fprintf('%10i  [%6.4f,%6.4f]  [%6.4f,%6.4f]\n', ...
            nlabels1(li), score1,score2, reg_score1, reg_score2);
        K3res(li,:) = [mean(scorevec(:)) mean(reg_scorevec(:)) score1 score2 reg_score1 reg_score2];
    end
fprintf('\n');

%% Write the latex table
for i=1:size(K1res,1)
    fprintf(' %2i & %2i & %5.3f & %5.3f & [%4.2f & %4.2f] & [%4.2f & %4.2f] \\\\ \n',...
        nlabels(i),nerrs(i), K1res(i,:));
end

for i=1:size(K2res,1)
    fprintf(' %2i & %2i & %5.3f & %5.3f & [%4.2f & %4.2f] & [%4.2f & %4.2f] \\\\ \n',...
        nlabels(i),nerrs(i), K2res(i,:));
end

for i=1:size(K3res,1)
    fprintf(' %2i & %2i & %5.3f & %5.3f & [%4.2f & %4.2f] & [%4.2f & %4.2f] \\\\ \n',...
        nlabels1(i),nerrs1(i), K3res(i,:));
end
