function xy = block_layout(npts)

nblocks = numel(npts);
bfrac = npts./sum(npts);

xycenter = zeros(2,nblocks);
rads = zeros(1,nblocks); %radius of each layout area

offset = 0;
for i=1:nblocks
    theta = offset + (bfrac(i)/2)*2*pi;
    xycenter(:,i) = [cos(theta); sin(theta)];
    rads(i) = norm(xycenter(:,i) - [cos(offset); sin(offset)]);
    offset = offset + bfrac(i)*(2*pi);
end

xy = zeros(sum(npts),2);
offset = 1;
for i=1:nblocks
    np = npts(i);
    R = (rads(i)/2)*[cos(0:(2*pi)/(np):2*pi)' sin(0:(2*pi)/(np):2*pi)'];
    R(end,:) = [];
    %R = (rads(i)/2)*randn(npts(i),2);
    R(:,1) = R(:,1) + xycenter(1,i);
    R(:,2) = R(:,2) + xycenter(2,i);
    xy(offset:(offset + npts(i)-1),:) = R;
    offset = offset + npts(i);
end
    