nlabels = 3;
beta = 0.99;
alpha = (1-beta)/beta;
kappa = 1e-5;

rng(1);
[A,labels] = bigblock([800,200,500],[0.05,0.03,0.06],0.01);
d = full(sum(A,2));
n = size(A,1);
classes = unique(labels);
nclasses = numel(classes);

p = randperm(n);
train_set = zeros(n,1);
pl = labels(p);
[cp,ia] = unique(pl,'first'); %pl(ia) = c
train_set(p(ia)) = 1;
test_set = ~train_set;
test_labels = labels(test_set)';

p(ia) = [];
train_set(p(1:(nlabels - nclasses))) = 1;

Y = full(sparse(find(train_set),labels(logical(train_set)),1,n,nclasses));
Yt = diag(1./sqrt(d))*Y; 

tic;
Pred = zeros(size(Y));
for c=1:nclasses
    s = Y(:,c);
    assert(all(s >= 0));
    s = sparse(s);
    
    
    pralpha = 1/(1+alpha);
    volS = sum(d.*s);
    v = (d.*s)/volS;
    v = sparse(v);
    d = full(d);
    A = sparse(A);

    tau = kappa*beta/volS;
    %[x,r,s] = pprfast(A, d, beta, v, tau, 'tol',sqrt(eps(1)));
    x = (diag(d) - beta*A)\((1-beta)*v);
    x = x.*d;
    zt = (x./d)*volS;
    Pred(:,c) = zt;
end
toc
plot(Pred)