nlabels = 3;
beta = 0.99;
alpha = (1-beta)/beta;
kappa = 1e-5;
blocksizes = [30,10,20];

rng(1);
[A,labels] = bigblock(blocksizes,[0.6,0.95,0.7],0.08);
xy = block_layout(blocksizes);
A = A - diag(diag(A));

d = full(sum(A,2));
n = size(A,1);
classes = unique(labels);
nclasses = numel(classes);

p = randperm(n);
train_set = zeros(n,1);
pl = labels(p);
[cp,ia] = unique(pl,'first'); %pl(ia) = c
train_set(p(ia)) = 1;
test_set = ~train_set;
test_labels = labels(test_set)';

p(ia) = [];
train_set(p(1:(nlabels - nclasses))) = 1;

Y = full(sparse(find(train_set),labels(logical(train_set)),1,n,nclasses));

[~,Ys] = zhou_ssl_2(A,Y); plot(Ys)


%%
Ys = (diag(d) - beta*A)\(diag(d)*Y); plot(Ys)

%%
[~,Ys] = zhou_ssl_1(A,Y); plot(Ys)
%%
[~,Ys] = joachims_ssl(A,Y); plot(Ys)
%%
[~,Ys] = zgl_ssl(A,Y); plot(Ys)

%%

fgplot(A,xy,'style','thick')