%% Try out an interation based on the inverse


A = load_graph('four-clusters');
n = size(A,1);
d = full(sum(A,2));
alpha = 0.85;
tol = 1e-4;
v = zeros(n,1);
v(1) = 1;

P = diag(sparse(1./d))*A;

%%
[xr,rr] = acl_method_1(P, (1-alpha)*v, d, alpha, tol);

%%
z = (eye(n) - alpha*P')\(tol*d);
xs = (eye(n) - alpha*P')\((1-alpha)*v);
x = xs;
shat = z;
s = (eye(n) - alpha*P')*shat;
%%
for i=1:100
    % alg: 
    %x = x - (xs - z)
    x = x - s;
    x = max(x,0);
    shat = z - (xs - x);
    s = (eye(n) - alpha*P')*shat;
    r = (eye(n) - alpha*P')*(xs - x);
    %x = max(x-c,0);
    fprintf('%11.3e  %11.3e  %11.3e %11.3e\n', sum(x), sum(xs - x), x'*s, sum(max(r - tol*d,0)));
end

%% Fix bad termination criteria
[xr,rr] = acl_method_1(P, (1-alpha)*v, d, alpha, tol);

%%
% [bestset,cond,cut,vol,y] = pprpush_weighted_mex(A,degs,set,eps,alpha)
%[bestset,cond,cut,vol,y] = pprpush_weighted_mex(A, d, 1, tol, alpha);
[xt,rt,st] = pprpush_inverse(A, d, alpha, v, tol);

%%
norm(xt-xr,inf)

%% Okay, now test our hybrid algorithm
[xt,rt,st] = pprfast(A, d, alpha, v, tol, eps(1));

%%
norm(xt-xr,inf)

