nlabels = 20;
beta = 0.99;
alpha = (1-beta)/beta;
kappa = 1e-5;

rng(1);
[A,labels] = bigblock([800,200,500],[0.05,0.03,0.06],0.01);
d = full(sum(A,2));
n = size(A,1);
classes = unique(labels);
nclasses = numel(classes);

p = randperm(n);
train_set = zeros(n,1);
pl = labels(p);
[cp,ia] = unique(pl,'first'); %pl(ia) = c
train_set(p(ia)) = 1;
test_set = ~train_set;
test_labels = labels(test_set)';

p(ia) = [];
train_set(p(1:(nlabels - nclasses))) = 1;

Y = full(sparse(find(train_set),labels(logical(train_set)),1,n,nclasses));
Yt = diag(1./sqrt(d))*Y; 

tic;
Pred = zeros(size(Y));
for c=1:nclasses
    s = Y(:,c);
    assert(all(s >= 0));
    s = sparse(s);
    
    
    pralpha = 1/(1+alpha);
    volS = sum(d.*s);
    v = (d.*s)/volS;
    v = sparse(v);
    d = full(d);
    A = sparse(A);

    tau = kappa*beta/volS;

    % it's the last return because it isn't usually do this!
    %[~,~,~,~,x] = pprpush_weighted_mex(A, d, v, tau, beta, sqrt(eps(1)));
    %[~,~,~,~,x1] = pprpush_weighted_mex(A, d, v, tau, beta, sqrt(eps(1)));
    %[x,r,s] = pprpush_early_stop(A, d, beta, v, tau);
    %[x,r,s] = pprpush_inverse(A, d, beta, v, tau, sqrt(eps(1)));
    [x,r,s] = pprfast(A, d, beta, v, tau, sqrt(eps(1)));
    norm(x1 - x);
    %x = acl_method_1(normout(A), (1-beta)*v, d, beta, tau);    


    zt = (x./d)*volS;
end
toc
        