function [x,r,s] = pprpush_early_stop(A, d, beta, v, tau)

n = size(A,1);
x = zeros(n,1);
r = (1-beta)*v;
rp = max(r - tau*d,0);
s = tau*d - r;
maxit = 10*n;

% two timers, t0 is start, t1 is increment, dt1 is print increment
t0 = tic; t1 = tic; print1 = 1; dt1 = t0 + 5;

for i=1:maxit
    x = x + rp;
    r = (1-beta)*v + beta*A'*(x./d) - x;
    rp = max(r - tau*d,0);
    s = tau*d - r;
    dt = toc(t1);
    if dt > dt1
        if print1 % print the header
            fprintf('  %5s  %11s  %11s  %11s\n', 'iter', 'sum rp', 'dual', 'sum x');
            fprintf('  -----  -----------  -----------  -----------\n');
        end
        fprintf('  %5i  %11.3e  %11.3e  %11.3e\n', i, sum(rp), x'*s/n, sum(x));
        t0 = tic;
        print1 = 0;
    end
    if x'*s/n > -sqrt(eps(1)) && sum(rp) < sqrt(eps(1))
        break;
    end
end



