%% This experiment is designed to demonstrate how Joachims SSL is better
%  when the graph has some nice structures.
%  we try a block model with errors in the labels.
%
%  We then updated it to see that ZGL is even better in this case (as might
%  be expected.)
n = 150;
ntrials = 200;
nl = 50;
nerr = 35;

errs = zeros(ntrials,3);
for i=1:ntrials
    [A,labels] = bigblock([n,n],[0.35,0.35],0.01);
    L = sparse([1:nl (nl+1):(nl+nerr) (1:nl)+n ((nl+1):(nl+nerr))+n],...
        [ones(nl,1); randi(2,nerr,1); 2*ones(nl,1); randi(2,nerr,1);], ...
        1, 2*n, 2);
    [p,Y] = joachims_ssl(A,L);
    errs(i,1) = norm(p-labels,1);
    [p,Y] = zhou_ssl_2(A,L);
    errs(i,2) = norm(p-labels,1);
    [p,Y] = zgl_ssl(A,L);
    errs(i,3) = norm(p-labels,1);
end
mean(errs)

