%%
A = load_graph('netscience-cc');
%%
xy = igraph_draw(A);
%%
%save 'xy_1.mat' A xy;
%%
load xy_1
%%
%S = xy(:,2) < -500; clf;
S = xy(:,1) < 25; clf;
S = S | (xy(:,1) > 145  & xy(:,2) < -350 & xy(:,1) < 150); 
fgplot(A,xy,'style','thick'); hold on;
scatter(xy(S,1),xy(S,2),100,'b','filled');
%%
A = A - diag(diag(A));
Ak = eye(size(A));
k = 5;
for i=1:k
    Ak = A*Ak + eye(size(A));
end
Ak = Ak - diag(diag(Ak));
%%
imagesc(log10(Ak)); colormap(hot);
%%
d = sum(A,2);
v1 = d.*S; v1 = v1 / sum(v1); v1 = sparse(v1);
x = (diag(d) - 0.99*A) \ (v1);
fgplot(A,xy,'style','thick'); hold on;
scatter(xy(:,1),xy(:,2),100,log10(x),'filled'); colormap(hot);
hold off;

%%
cmap = @() colormap(1-hot(5));
gdraw = @() fgplot(A,xy,'style','thick','MarkerColor',[1,1,1],'MarkerSize',1);
%%
d = sum(A,2);
v1 = d.*S; v1 = v1 / sum(v1); v1 = sparse(v1);
x = (diag(d) - 0.99*A) \ (v1);
clf;
gdraw(); hold on;
scatter(xy(:,1),xy(:,2),100,log10(x),'filled'); cmap();
hold off;

%%
d = sum(A,2);
%x = (diag(dk) - 0.99*Ak) \ (v2);
x = prl1_sweep(@(kappa) prl1_fast(A,0.0101,S,d,kappa),0.4,0.3);
gdraw(); hold on;
scatter(xy(:,1),xy(:,2),100.*(x > 0)+0.1*(x==0),log10(x),'filled'); cmap();
hold off;

%%
dk = sum(Ak,2);
vk = dk.*S; vk = vk / sum(vk); vk = sparse(vk);
x = (diag(dk) - 0.99*Ak) \ (v2);
fgplot(A,xy,'style','thick'); hold on;
scatter(xy(:,1),xy(:,2),100,log10(x),'filled');  cmap;
text(164.0744, -143.7977, 'Reduced Errors');
hold off;


%%
dk = sum(Ak,2);
vk = dk.*S; vk = vk / sum(vk); vk = sparse(vk);
x = prl1_sweep(@(kappa) prl1_fast(Ak,0.0101,S,dk,kappa),0.4,0.3);
gdraw(); hold on;
scatter(xy(:,1),xy(:,2),100.*(x > 0)+0.1*(x==0),log10(x),'filled'); cmap();
hold off;

