function experiment_usps_plots



%% Make the plot
load usps_results

%%
usps_plot(nlabels, results(1).errrate);
print(gcf,'errrate-sigma-1-1-4.eps','-depsc2');

usps_plot(nlabels, results(2).errrate);
print(gcf,'errrate-sigma-2-1-4.eps','-depsc2');

usps_plot(nlabels, results(3).errrate);
print(gcf,'errrate-sigma-1-5-8.eps','-depsc2');

usps_plot(nlabels, results(4).errrate);
print(gcf,'errrate-sigma-2-5-8.eps','-depsc2');


%% OLD plots
return;
%%
errrate = results(2).errrate;
clf; hold all;
h = zeros(4,1);
for i=1:4
    h(i) = plot(nlabels, median(errrate(:,:,i),2));
    plot(nlabels, prctile(errrate(:,:,i),75,2),'--','Color',get(h(i),'Color'));
    plot(nlabels, prctile(errrate(:,:,i),25,2),'--','Color',get(h(i),'Color'));
end
legend(h,'Kernel 1', 'Kernel 2', 'Kernel 3', 'Cuts');
%%
errrate = results(2).errrate;
clf; hold all;
h = zeros(4,1);
for i=1:4
    data = errrate(:,:,i);
    data = sort(data,2)';
    labels = repmat(nlabels,100,1) + repmat((-1:(2/99):1)',1,6);
    
    plot(labels(:),data(:),'.');
    
end
legend(h,'Kernel 1', 'Kernel 2', 'Kernel 3', 'Cuts');



function usps_plot(nlabels, errrate)
h = plot(nlabels, squeeze(median(errrate,2)),'o-');
set(h(1),'LineStyle','--','Marker','*');
set(h(2),'LineStyle','-.','Marker','+');
set(h(3),'LineStyle',':');
legend('K1', 'K2', 'K3', 'RK3');
ylim([0,1]);
xlim([0,55]);
legend boxoff;
set_figure_size([3,2.5]);
xlabel('Num. labels');
ylabel('Error rate');
