results = [];

results(end+1).digs = [2,3,4,5];
results(end).rad = 1.25;
[Preds,labels] = experiment_usps_roc(results(end).digs,results(end).rad,20);
results(end).Preds = Preds;
results(end).labels = labels;
save 'usps_roc.mat' results
%%
results(end+1).digs = [6,7,8,9];
results(end).rad = 1.25;
[Preds,labels] = experiment_usps_roc(results(end).digs,results(end).rad,20);
results(end).Preds = Preds;
results(end).labels = labels;
save 'usps_roc.mat' results

results(end+1).digs = [2,3,4,5];
results(end).rad = 2.5;
[Preds,labels] = experiment_usps_roc(results(end).digs,results(end).rad,20);
results(end).Preds = Preds;
results(end).labels = labels;
save 'usps_roc.mat' results

results(end+1).digs = [6,7,8,9];
results(end).rad = 2.5;
[Preds,labels] = experiment_usps_roc(results(end).digs,results(end).rad,20);
results(end).Preds = Preds;
results(end).labels = labels;
save 'usps_roc.mat' results

%%
funcs = {'K1','K2','K3','RK3'};
for i=1:numel(results)
    clf; 
    r = results(i);
    for f=funcs 
        f = f{1};
        for c=1:4
            subplot(2,2,c); hold all;
            P = r.Preds.(f);
            [px,py] = perfcurve(r.labels, P(:,c), c); 
            plot(px,py);
        end
    end
    %title('\\sigma = %f', r.rad);
    pause;
end   
%% Pick out the helpful
r = results(1);
c = 3; 
clf; hold all;
for f=funcs 
    f = f{1};
    P = r.Preds.(f);
    [px,py] = perfcurve(r.labels, P(:,c), c); 
    plot(px,py,'LineWidth',1.5);
end
title(sprintf('3 vs. 1,2,3,4, \\sigma=%.2f', r.rad));
xlabel('false pos.');
ylabel('true pos.')
legend(funcs{:},'Location','Southeast'); legend boxoff;
text(0.4,0.85,'RK3');
text(0.2,0.95,'K1');
set_figure_size([2.5,2.5]);
print('roc-3-1234-125.eps','-depsc2');

%%
r = results(2);
c = 2; 
clf; hold all;
for f=funcs 
    f = f{1};
    P = r.Preds.(f);
    [px,py] = perfcurve(r.labels, P(:,c), c); 
    plot(px,py,'LineWidth',1.5);
end
title(sprintf('6 vs. 5,6,7,8, \\sigma=%.2f', r.rad));
xlabel('false pos.');
ylabel('true pos.')
legend(funcs{:},'Location','Southeast'); legend boxoff;
text(0.3,0.935,'K1');
set_figure_size([2.5,2.5]);
print('roc-6-5678-125.eps','-depsc2');

%%
clf; hold all;
r = results(3);
c = 2;
for f=funcs 
    f = f{1};
    P = r.Preds.(f);
    [px,py] = perfcurve(r.labels, P(:,c), c); 
    plot(px,py,'LineWidth',1.5);
end
title(sprintf('2 vs. 5,6,7,8, \\sigma=%.2f', r.rad));
xlabel('false pos.');
ylabel('true pos.')
legend(funcs{:},'Location','Southeast'); legend boxoff;
text(0.1,0.97,'RK3');
text(0.2,0.45,'K1');
text(0.166,0.84,'K2');
text(0.133,0.9,'K3');
set_figure_size([2.5,2.5]);
print('roc-2-1234-25.eps','-depsc2');

%%
clf; hold all;
r = results(4);
c = 4;
for f=funcs 
    f = f{1};
    P = r.Preds.(f);
    [px,py] = perfcurve(r.labels, P(:,c), c); 
    plot(px,py,'LineWidth',1.5);
end
title(sprintf('8 vs. 5,6,7,8, \\sigma=%.2f', r.rad));
xlabel('false pos.');
ylabel('true pos.')
legend(funcs{:},'Location','Southeast'); legend boxoff;
text(0.025,1.025,'RK3');
text(0.5,0.45,'K1');
text(0.333,0.95,'K2');
text(0.166,0.965,'K3');
set_figure_size([2.5,2.5]);
print('roc-8-5678-25.eps','-depsc2');
