function [p,Y] = joachims_ssl_fast(A,d,L)
% function [p,Y] = joachims_ssl(A,L)
%   P the predicted labels
%   Y the numeric predictions

%ssl_check(A,L);

l = sum(L,2);

cc = components(sparse(A));
nc = max(cc);
if nc > 1
    Y = zeros(size(L));
    % handle each component
    for c=1:nc
        filt = (cc==c);
        Y(filt,:) = (diag(d(filt)) - A(filt,filt) + diag(l(filt))) \ L(filt,:);
    end
else
    Y = (diag(d) - A + diag(l)) \ L;
end
    
p = ssl_round(Y,L);