

%%
erates = usps_errrate([1,7,9],2.5,3,4,0.5); 
squeeze(median(erates,2))

%%
erates = usps_errrate([1,7,9],1.5,3,4,0.5); 
squeeze(median(erates,2))

%% See if we still have the weird nlabels effect with the err rates
% We don't see it anymore,
% This example shows that when sigma is untuned, the order is much more
% dependenable than the values. In either case, the 
erates = usps_errrate([1,7,9],2.5,[1,2,3,5,10],10); 
%%
rank_round = mean(erates,2);
rank_round = squeeze(rank_round(:,:,:,1))
plot([1,2,3,5,10],rank_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
val_round = mean(erates,2);
val_round = squeeze(val_round(:,:,:,3))
plot([1,2,3,5,10],val_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
plot([1,2,3,5,10],[rank_round(:,2:end),val_round(:,[6,4])]);
legend('K2','K3','RK3','J','RK2','VRK2','VRK3');

%% If we still have the weird nlabels effect with the err rates
% This example shows that when sigma is untuned, the order is much more
% dependenable than the values. In either case, the 
rng(1);
erates = usps_errrate([1,7,9,10],1.25,[1,2,3,5,7,10],10); 
%%
rank_round = median(erates,2);
rank_round = squeeze(rank_round(:,:,:,1))
plot([1,2,3,5,7,10],rank_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
val_round = median(erates,2);
val_round = squeeze(val_round(:,:,:,3))
plot([1,2,3,5,7,10],val_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
h=plot([2,3,5,7,10],[rank_round(:,1:end),val_round(:,[6,4])]);
set(h(end),'LineStyle','--');
legend('K1','K2','K3','RK3','J','RK2','VRK2','VRK3');

%%
% Oh, interesting 


%% What happens if we stick some errors in?
rng(1);
erates = usps_errrate([1,7,9,10],1.25,[2,3,5,7,10],10,0.1*ones(5,1)); 

%%
rank_round = median(erates,2);
rank_round = squeeze(rank_round(:,:,:,1))
plot([2,3,5,7,10],rank_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
val_round = median(erates,2);
val_round = squeeze(val_round(:,:,:,3))
plot([2,3,5,7,10],val_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
h=plot([2,3,5,7,10],[rank_round(:,1:end),val_round(:,[6,4])]);
set(h(end),'LineStyle','--');
legend('K1','K2','K3','RK3','J','RK2','VRK2','VRK3');

%%
% That showed a weak effect, let's try something stronger.
rng(1);
erates = usps_errrate([1,7,9,10],1.25,[2,3,5,7,10],10,0.2*ones(5,1)); 

%%
rank_round = median(erates,2);
rank_round = squeeze(rank_round(:,:,:,1))
plot([2,3,5,7,10],rank_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
val_round = median(erates,2);
val_round = squeeze(val_round(:,:,:,3))
plot([2,3,5,7,10],val_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
h=plot([2,3,5,7,10],[rank_round(:,1:end),val_round(:,[6,4])]);
set(h(end),'LineStyle','--');
legend('K1','K2','K3','RK3','J','RK2','VRK2','VRK3');

%% 
% and what happens if we increase sigma & add noise?

%%
rng(1);
erates = usps_errrate([1,7,9,10],2.5,[2,3,5,7,10],10,0.2*ones(5,1)); 

%%
rank_round = median(erates,2);
rank_round = squeeze(rank_round(:,:,:,1))
plot([2,3,5,7,10],rank_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
val_round = median(erates,2);
val_round = squeeze(val_round(:,:,:,3))
plot([2,3,5,7,10],val_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
h=plot([2,3,5,7,10],[rank_round(:,1:end),val_round(:,[6,4])]);
set(h(end),'LineStyle','--');
legend('K1','K2','K3','RK3','J','RK2','VRK2','VRK3');
%% 
% Okay, we get basically what we expect -- no difference with
% regularization.

%%
% Final test, lower sigma and add noise
%%
rng(1);
erates = usps_errrate([1,7,9,10],0.8,[2,3,5,7,10],10,0.1*ones(5,1)); 

%%
rank_round = median(erates,2);
rank_round = squeeze(rank_round(:,:,:,1))
plot([2,3,5,7,10],rank_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
val_round = median(erates,2);
val_round = squeeze(val_round(:,:,:,3))
plot([2,3,5,7,10],val_round','.-'); legend('K1','K2','K3','RK3','J','RK2');
%%
h=plot([2,3,5,7,10],[rank_round(:,1:end),val_round(:,[6,4])]);
set(h(end),'LineStyle','--');
legend('K1','K2','K3','RK3','J','RK2','VRK2','VRK3');



