%% Useful for playing and experiments with usps_roc experiments

rng(1);
[Preds,labels] = usps_roc([1,7,9,10],2.5,20,0);
[AUC,wmean] = preds_auc(Preds,labels)
structfun(@mean,AUC)
%%
usps_roc_plot(Preds,labels);

%%
% With no errors, there is almost no difference between the methods.
% K1 is horrible, but the others are all about the same.

%% Regularization makes a weak difference here.
% 
rng(1);
[Preds,labels] = usps_roc([1,7,9,10],1.25,30,0.5); % 50% error rate
[AUC,wmean] = preds_auc(Preds,labels)
structfun(@mean,AUC)

%% This case shows a bigger effect
rng(1);
[Preds,labels] = usps_roc([1,7,9,10],0.625,30,0.2); % 20% error rate
[AUC,wmean] = preds_auc(Preds,labels)
structfun(@mean,AUC)

%% This case shows a bigger effect
rng(1);
[Preds,labels] = usps_roc([1,7,9,10],0.625,30,0.1); % 10% error rate
[AUC,wmean] = preds_auc(Preds,labels)
structfun(@mean,AUC)

%% Is this one even bigger?

rng(1);
[Preds,labels] = usps_roc([1,7,9,10],0.8,30,1); % 20% error rate
[AUC,wmean] = preds_auc(Preds,labels)
structfun(@mean,AUC)



%% 
% Strange, it seems regularization helps more when it's sparse vs. dense
% I guess this makes sense from a 'flow' stand-point.

%%
usps_roc_plot(Preds,labels);

%%
[Preds,labels] = usps_roc([1:10],1,50,0.2);
[AUC,wmean] = preds_auc(Preds,labels)
structfun(@mean,AUC)

