load final_usps_errrate_sigma

nl = 1;
nlab = nlabels(nl);
prclo = 20;
prchi = 80;
xentries = rads;
subset = [2,6];

imax = numel(xentries);
for i=1:numel(xentries)
    if numel(erates{i}) == 0, imax=i-1; break; end
end
if imax<numel(xentries)
    fprintf('Missing data!\n');
end
rank_round = zeros(imax,numel(subset));
rank_roundlo = rank_round;
rank_roundhi = rank_round;
for i=1:imax
    erate = erates{i}(nl,:,subset,1);
    rank_round(i,:) = median(erate);
    rank_roundlo(i,:) = prctile(erate,prclo);
    rank_roundhi(i,:) = prctile(erate,prchi);
end
xentries = xentries(1:imax);

%%
clf;
h = plot(xentries,rank_round,'.-'); hold on;
set([h(1)],'LineStyle','--');

for si=1:numel(subset)
    color = get(h(si),'Color');
    p25 = rank_roundlo(:,si);
    p75 = rank_roundhi(:,si);
    hp = patch([xentries fliplr(xentries)],[p25' fliplr(p75')],0.15*color + 0.85*[1,1,1]);
    set(hp,'EdgeColor','none');
end

h = plot(xentries,rank_round,'.-','MarkerSize',12,'LineWidth',1); 
set([h(1)],'LineStyle','--','Marker','x','MarkerSize',10);
xlim([min(xentries)*0.95, max(xentries)*1.05]);
ylim([0,.4])
ylabel('error rate');
xlabel('\sigma');
box off;
legend(h,'Zhou','Zhou+Push'); legend boxoff;
for i=1:numel(xentries)
    text(xentries(i),0.05,sprintf('%.1f\n',xentries(i)),'Rotation',90,'VerticalAlignment','top');
end

%%
set_figure_size([2.5,2.5]);
print('digits-errrate-sigma.eps','-depsc2','-painters');

%%
!cp *errrate-sigma*.eps ~/Dropbox/publications/alg-anti-diff-icml/robust-diffusion-paper/Try4-dgleich/figures/
    