%% Plot final errrate 1

load final_usps_errrate_1

%% Plot showing the difference between the two types of regularizations
rank_round = squeeze(erates(:,:,:,1));
rk2_diff = rank_round(:,:,2) - rank_round(:,:,6);
rk3_diff = rank_round(:,:,3) - rank_round(:,:,4);
rk2_reldiff = (rank_round(:,:,2) - rank_round(:,:,6))./rank_round(:,:,2);
rk3_reldiff = (rank_round(:,:,3) - rank_round(:,:,4))./rank_round(:,:,3);
median(rk2_diff,2)./median(rank_round(:,:,2),2)
median(rk3_diff,2)./median(rank_round(:,:,3),2)

median(rk2_reldiff,2)
median(rk3_reldiff,2)


%% Plotting for picking classes based on the rank of the prediction
rank_round = median(erates,2);
rank_round = squeeze(rank_round(:,:,:,1));
rank_round20 = prctile(erates,20,2);
rank_round20 = squeeze(rank_round20(:,:,:,1));
rank_round80 = prctile(erates,80,2);
rank_round80 = squeeze(rank_round80(:,:,:,1));
subset = [2,6,3,4]; % K2,RK2,K3,RK3,J
clf;
h = plot(nlabels,rank_round(:,subset),'.-'); hold on;
set([h(1),h(3)],'LineStyle','--');
%plot(nlabels,rank_round20(:,subset),':');
%plot(nlabels,rank_round80(:,subset),':');

for si=1:numel(subset)
    s = subset(si);
    color = get(h(si),'Color');
    p25 = rank_round20(:,s);
    p75 = rank_round80(:,s);
    hp = patch([nlabels fliplr(nlabels)],[p25' fliplr(p75')],0.15*color + 0.85*[1,1,1]);
    set(hp,'EdgeColor','none');
end
h = plot(nlabels,rank_round(:,subset),'.-','MarkerSize',12,'LineWidth',1); 
set([h(1),h(3)],'LineStyle','--');
xlim([2,10]);
ylim([0,.6])
ylabel('error rate');
xlabel('average training samples per class');
box off;
legend(h,'K2','RK2','K3','RK3'); legend boxoff;

%%
%set_figure_size([3,3]);
%print('digits-errrate-rank-0689-25-50.eps','-depsc2');

%% Plotting for picking classes based on the value of the prediction

% NOTE, the variable rank_round is incorrectly named here, but, that's just
% an artifact of the cut-paste nature;
rank_round = median(erates,2);
rank_round = squeeze(rank_round(:,:,:,3));
rank_round20 = prctile(erates,20,2);
rank_round20 = squeeze(rank_round20(:,:,:,3));
rank_round80 = prctile(erates,80,2);
rank_round80 = squeeze(rank_round80(:,:,:,3));
subset = [2,6,3,4]; % K2,RK2,K3,RK3
clf;
h = plot(nlabels,rank_round(:,subset),'.-'); hold on;
set([h(1),h(3)],'LineStyle','--');

for si=1:numel(subset)
    s = subset(si);
    color = get(h(si),'Color');
    p25 = rank_round20(:,s);
    p75 = rank_round80(:,s);
    hp = patch([nlabels fliplr(nlabels)],[p25' fliplr(p75')],0.15*color + 0.85*[1,1,1]);
    set(hp,'EdgeColor','none');
end
h = plot(nlabels,rank_round(:,subset),'.-','MarkerSize',12,'LineWidth',1); 
set([h(1),h(3)],'LineStyle','--');


%plot(nlabels,rank_round20(:,subset),':');
%plot(nlabels,rank_round80(:,subset),':');
ylim([0,.6])
xlim([2,10]);
ylabel('error rate');
xlabel('average training samples per class');
box off;
legend(h,'K2','RK2','K3','RK3','Location','Southwest'); legend boxoff;
%%
%set_figure_size([3,3]);
%print('digits-errrate-vals-0689-25-50.eps','-depsc2');