function [AUC,wmean,cfreq] = preds_auc(Preds,labels)

[classes,~,ic] = unique(labels);
nclasses = numel(classes);
funcs = fieldnames(Preds);

for fi=1:numel(funcs)
    f = funcs{fi};
    P = Preds.(f);
    if size(P,1) == numel(labels)
        assert(size(P,2) == nclasses)
        auc = zeros(1,nclasses);
        for c=1:nclasses
            [~,~,~,auc(c)] = perfcurve(labels, P(:,c), c); 
        end
        AUC.(f) = auc;
    end
end

% compute the class percentages in the test set
cfreq = accumarray(ic(:),1);
cfreq = cfreq/sum(cfreq);
wmean = structfun(@(x) cfreq'*x(:),AUC);
