
%nlabels = [5,10];
nlabels = 5;
digits = 1:10;
nerrors = 0.2*ones(numel(nlabels),1);
ntrials = 25;

%% We have the following pairs from 
% study_usps_errrate_sparse_dense
% So we have the following pairs
%  nn=13, nn=3,k=2 => avgdeg ~18
%  nn=28, nn=5,k=2 => avgdeg ~39
%  nn=37, nn=3,k=3 => avgdeg ~52
%  nn=73, nn=10,k=2 => avgdeg ~103
%  nn=97, nn=5,k=3 => avgdeg ~137
%  nn=230, nn=25,k=2 => avgdeg ~322

nncase = [13, 3,2;
          28, 5,2;
          37, 3,3;
          73, 10,2;
          97, 5,3;
          97, 3,4;];

%%
erates = cell(size(nncase,1),3);
avgdeg = zeros(size(nncase,1),3);
for ri=1:size(nncase,1)
    rng(1);
    ccase = nncase(ri,:);
    nn = ccase(1);
    
    nn2 = ccase(2);
    k2 = ccase(3);
    
    % compute the base case
    rng(1);
    data = usps_setup_unify(digits,'nn',nn2);
    avgdeg(ri,1) = nnz(data.G)/data.n;
    erates{ri,1} = usps_errrates_unify(...
        data, nlabels, ntrials, nerrors, 'useparfor', true);
    
    rng(1);
    data = usps_setup_unify(digits,'nn',nn2,'kpow',k2);
    avgdeg(ri,2) = nnz(data.G)/data.n;
    erates{ri,2} = usps_errrates_unify(...
        data, nlabels, ntrials, nerrors, 'useparfor', true);
    
    rng(1);
    data = usps_setup_unify(digits,'nn',nn);
    avgdeg(ri,3) = nnz(data.G)/data.n;
    erates{ri,3} = usps_errrates_unify(...
        data, nlabels, ntrials, nerrors, 'useparfor', true);
    
    save 'final_usps_errrate_densify_k.mat' erates nncase avgdeg digits nlabels ntrials nerrors
end

