function save_usps_roc_plot(outfile,Preds,labels,digits,rad)
nclasses = numel(unique(labels));
if nargin < 3
    digits = 1:nclasses;
end
if nargin < 4
    rad = -1;
end
funcs = fieldnames(Preds);

clf;

    for c=1:nclasses
        %%
        curc = char(digits(c)-1+'0');
        digstr = char(digits-1+'0');
        sigstr = strrep(num2str(rad),'.','');
        
        clf; hold all;
        filter = false(numel(funcs),1);
        for fi=1:numel(funcs)
            f = funcs{fi};
            P = Preds.(f);
            if size(P,1) == numel(labels)
                [px,py] = perfcurve(labels, P(:,c), c); 
                plot(px,py,'LineWidth',1.5);
                filter(fi) = 1;
            end
        end
        title(sprintf('%s vs. %s, \\sigma=%.2f',curc, strjoin(cellstr(digstr'),','), rad));
        %title('\\sigma = %f, set = %s, char = %s', r.rad, digstr, curc)
        xlabel('false pos.');
        ylabel('true pos.');
        legend(funcs{filter},'Location','Southeast'); legend boxoff;
        set_figure_size([2.5,2.5]);
        print(sprintf('%s-%s-%s-%s.eps', outfile, curc, digstr, sigstr),'-depsc2');
    end