load final_usps_errrate_densify_k

%%
nl=1;
nlab=nlabels(nl);
subset=[2,6];

%%
ncase = size(nncase,1);
imax = ncase;
for i=1:ncase
    if isempty(erates{i,3}), imax=i-1; fprintf('Missing data\n'); break; end
end
nncase = nncase(1:imax,:);
ncase = imax;

%%
fprintf('\\toprule \n');
fprintf('Neighs. & Avg.~Deg & Neighs. & $k$ & Avg.~Deg \\\\ \\midrule \n')
for i=1:ncase
    fprintf('%7i & %8.1f & %7i & %3i & %8.1f \\\\ \n', ...
        nncase(i,1), avgdeg(i,3), nncase(i,2), nncase(i,3), avgdeg(i,2));
end
fprintf('\\bottomrule \n');
    
    
%%
afunc = @(x) median(x);
fprintf('         & Zhou    &           & \\multicolumn{2}{l}{Zhou w.~Push} \\\\  \n');
fprintf('Avg.~Deg &  $k=1$  & $k \\ge 1$ &  $k=1$  & $k \\ge 1$ \\\\ \\midrule \n');
for i=1:ncase
    fprintf('%8i & %7.3f & %9.3f & %7.3f & %9.3f \\\\ \n', ...
        round(avgdeg(i,3)), ...
        afunc(erates{i,3}(nl,:,subset(1),1)), ...
        afunc(erates{i,2}(nl,:,subset(1),1)), ...
        afunc(erates{i,3}(nl,:,subset(2),1)), ...
        afunc(erates{i,2}(nl,:,subset(2),1)));
end
    