%% Show how adding regularization to usps regularizes away the signal
clear;
rad = 0.8;
digits = [1,7,9,10];
data = usps_setup(digits,rad);
struct2vars(data);

%%
nlabels = 40;
nerrors = 0.1;
sranges = [0.75,0.5; 0.5,0.4; 0.4,0.3; 0.3,0.2; 0.2,0.1];

%%
classes = unique(labels);
nclasses = numel(classes);
rng(10); % isn't bad
[test_set,test_labels,train_set,train_labels] = build_test_train(labels,nlabels,nerrors);
Y = full(sparse(find(train_set),train_labels,1,n,nclasses));

%%
test_filt = @(x) x(test_set,:);

PredMat = zeros(numel(test_labels),nclasses);
Preds.K2 = test_filt(iK2(repmat(d,1,nclasses).*Y));
Preds.RK2_L = PredMat;
for c=1:nclasses
    s = Y(:,c);
    
    prl1 = @(kappa) prl1_custom(G,alpha,(s>0),d,kappa,prsolverG);
    Preds.RK2_L(:,c) = test_filt(prl1_sweep(prl1,0.5,0.4));
end
Preds.RK2_M = PredMat;
for c=1:nclasses
    s = Y(:,c);
    
    prl1 = @(kappa) prl1_custom(G,alpha,(s>0),d,kappa,prsolverG);
    Preds.RK2_M(:,c) = test_filt(prl1_sweep(prl1,0.4,0.3));
end
Preds.RK2_S = PredMat;
for c=1:nclasses
    s = Y(:,c);
    
    prl1 = @(kappa) prl1_custom(G,alpha,(s>0),d,kappa,prsolverG);
    Preds.RK2_S(:,c) = test_filt(prl1_sweep(prl1,0.3,0.2));
end


usps_roc_plot(Preds,test_labels,digits,rad);
%%
%%
save_usps_roc_plot('smallrad-regularize', Preds,test_labels,digits,rad);