function [Preds,test_labels,classes] = usps_roc(digits,rad,nlabels,nerrors) 

if ~exist('nerrors','var') || isempty(nerrors), nerrors = 0; end

data = usps_setup(digits,rad);
struct2vars(data); 

classes = unique(labels);
nclasses = numel(classes);

[test_set,test_labels,train_set,train_labels] = build_test_train(labels,nlabels,nerrors);
Y = full(sparse(find(train_set),train_labels,1,n,nclasses));

test_filt = @(x) x(test_set,:);

PredMat = zeros(numel(test_labels),nclasses);
Preds.K1 = test_filt(iK1(Y));
Preds.K2 = test_filt(iK2(repmat(d,1,nclasses).*Y));
Preds.K3 = test_filt(iK3(repmat(dw,1,nclasses).*Y));
Preds.RK3 = PredMat;
Preds.RK2 = PredMat;
for c=1:nclasses
    s = Y(:,c);
    
    prl1 = @(kappa) prl1_custom(G,alpha,(s>0),d,kappa,prsolverG);
    Preds.RK2(:,c) = test_filt(prl1_sweep(prl1,0.75,0.5));
    
    prl1 = @(kappa) prl1_custom(W,alpha,(s>0),dw,kappa,prsolverW);
    Preds.RK3(:,c) = test_filt(prl1_sweep(prl1,0.75,0.5));   
end

[~,Pred] = joachims_ssl_fast(G,d,Y);
Preds.J = test_filt(Pred);
Preds.nmissing = nmissing;