function [C,N] = pearson_similarity(R)


n = size(R,2);
C = eye(n,n);
N = zeros(n,n);

[~,rj] = find(R);
N = N + diag(full(accumarray(rj,1)));

dt = tic;
for i=1:n
    if mod(i,50)==0, fprintf('%5i - %s\n', i, toc(dt)); end
    for j=i+1:n
        x = R(:,i);
        y = R(:,j);
        xf = x.*(y~=0);
        yf = y.*(x~=0);
        nzx = nonzeros(xf);
        nzy = nonzeros(yf);
        mx = mean(nzx);
        my = mean(nzy);
        N(j,i) = nnz(xf);
        if nnz(xf) >= 4
            C(j,i) = (nzx - mx)'*(nzy-my)/(std(nzx)*std(nzy)*(nnz(xf)-1));
        end
    end
end
C = C + tril(C,-1)';
N = N + tril(N,-1)';

    