function [Pi,R] = ssl_cut_round(Pred,G,type)

if nargin < 3
    type = 'ncut';
end

%%
n = size(Pred,1);
assert(size(G,1) == n);

[~,P] = sort(Pred,'descend');
%%
R = Inf*ones(size(Pred));
for i=1:size(Pred,2)
    cutvals = fastcutsweep(G,P(:,i));
    cvals = cutvals.(type);
    [cutval,index] = min(cvals(1:floor(n/2)));
    R(P(1:index,i),i) = cutval; % THIS VALUE IS WEIRD
    % The reason we assign 1-cutval is that we want to be able
    % to assign by taking the max over rows of R. 
end
[vals,Pi] = min(R,[],2);
Pi(vals == Inf) = Inf; % report inf for no predictions
