nlabels = 3;
beta = 0.99;
alpha = (1-beta)/beta;
kappa = 1e-5;
blocksizes = [30,10,20];

rng(1);
[A,labels] = bigblock(blocksizes,[0.7,0.9,0.8],0.05);
A = A - diag(diag(A));
d = full(sum(A,2));
n = size(A,1);
nclasses = numel(blocksizes);

[test_set,test_labels,train_set] = build_test_train(labels,nlabels);
Y = full(sparse(find(train_set),labels(logical(train_set)),1,n,nclasses));

%%
Pred = zeros(size(Y));
for c=1:nclasses
    s = Y(:,c);
    assert(all(s >= 0));
    s = sparse(s);
    
    prl1 = @(kappa) prl1_fast(A,alpha,s,d,kappa);
    zt = prl1_sweep(prl1,1,0.5);
    
    Pred(:,c) = zt;
end

%%
Pi = ssl_cut_round(Pred,G,'ncut');
assert(Pi(end) == 1); 