n = 1000;
A = sprand(n,n,10/1000);
A = triu(A,1);
A = A + A';
d = full(sum(A,2));
P = diag(sparse(1./d))*A;
alpha = 0.85;
tol = 1e-3;
tpush = 0;
tgurobi = 0;
tcvx = 0;
for i=1:n
    vv = zeros(n,1);
    vv(i) = 1;
    cutalpha = (1-alpha)/alpha;
    cutkappa = d(i)*tol/alpha;
    t0 = tic;
    zpush = prl1_push(A, cutalpha, vv, d, cutkappa);
    tpush = tpush + toc(t0);
    t0 = tic;
    zgurobi = prl1_gurobi(A, cutalpha, vv, d, cutkappa);
    tgurobi = tgurobi + toc(t0);
    t0 = tic;
    zcvx = prl1_cvx(A, cutalpha, vv, d, cutkappa);
    tcvx = tcvx + toc(t0);
    if mod(i,10) == 0
        fprintf('node %4i tpush = %8.1f tgurobi = %8.1f tcvx = %8.1f\n', ...
            i, tpush, tgurobi, tcvx); 
    end
end