function [p,Y] = zhou_ssl_1(A,L,beta)
% function [p,Y] = zhou_ssl_1(A,L,beta)
%   P the predicted labels
%   Y the numeric predictions

% default value of beta is 0.99, mirroring Zhou
if nargin < 3
    beta = 0.99;
end

ssl_check(A,L);

d = sum(A,2);
alpha = (1-beta)/beta;

Y = zeros(size(L));
for i=1:size(L,2)
    pos = L(:,i);
    Y(:,i) = generic_ssl(A,alpha*pos,alpha*(d - pos),'node_weights',sqrt(d));
end
Y = (1/(1-beta))*Y;

p = ssl_round(Y,L);